% Yokogawa MEG Reader toolbox for MATLAB
% Version 1.04.00 06-May-2011
%
% Files
%   getYkgwData        - Get measured data
%   getYkgwHdrSystem   - Get header of the system information
%   getYkgwHdrChannel  - Get header of the system information
%   getYkgwHdrAcqCond  - Get header of the system information
%   getYkgwHdrEvent    - Get header of the trigger event
%   getYkgwHdrCoregist - Get header of the system information
%   getYkgwHdrDigitize - Get header of the digitization information
%   getYkgwHdrSubject  - Get header of the subject information
%   getYkgwHdrBookmark - Get header of bookmark
%   getYkgwHdrSource   - Get header of the source information
%   getYkgwMriHdr      - Get header of mri
%   getYkgwVersion     - Get toolbox version
%
%------------------------------------------------------------
%                          History
%------------------------------------------------------------
% R1.04.00 : 2011.05.06
%  [ getYkgwHdrAcqCond ]
%    - Add multi-trigger information
%  [ getYkgwHdrEvent ]
%    - support only EvokedRaw or EvokedAve
%  [ getYkgwHdrChannel ]
%    - remove the end of unnecessary spaces for channel name
%  [ getYkgwHdrDigitize ]
%    - fix .meg2digitizer .digitizer2meg
%  [ getYkgwMriHdr ]
%    - add HPI(marker) information
%
% R1.03.01 : 2011.04.13
%  [ getYkgwData ]
%    - Support internal function changes
%
% R1.03.00.01 : 2011.03.25
%  [ all functions ]
%    - Pcodes were generated by MATLAB R2007b.
%
% R1.03.00 : 2011.03.03
%  [ getYkgwData ]
%    - Support MegLaboratory R1.4.8 specific calibration for non-MEG channels
%  [ getYkgwHdrSource ]
%    - Structure fields which had not been used were removed.
%  [ getYkgwHdrBookmark ]
%    - Structure fields which had not been used were removed.
%
% R1.02.00 : 2011.02.14
%  [ all functions ]
%    - 1st argument (specifying a file) was modified from file ID to file path.
%  [ getYkgwData ]
%    - Fix EvokedRaw error if sample_length argument is omitted.
%  [ getYkgwHdrCoregist ]
%    - Add HPI(Head Position Indicator) fields (position and label)
%
% R1.01.00 : 2011.01.24
%  [ getYkgwData ]
%    - Not apply averaged gain to reference channels if system id is 1000 later. 
%
% R1.00.00 : 2010.06.24
%  - First release
% 
%-----------------------------------------------------------------------
% The Receiving Party shall strictly maintain the secrecy of any Confidential Information
% and shall not disclose any and all Confidential Information of
% YOKOGAWA Electric Corporation to any third parties.
% The Receiving Party shall refrain from reverse engineering, decompiling or disassembling
% in connection with the Confidential Information disclosed by YOKOGAWA Electric Corporation
% to the Receiving Party unless expressly permitted by applicable law.
%
% This toolbox is written for MATLAB version 7.5 (R2007b) onwards.
%
% This toolbox must not be used for clinical applications.
% If MEG data are processed by this toolbox, they should not be later employed
% for clinical and/or diagnostic purposes.
%
% Copyright (C) 2011 Yokogawa Electric Corporation, All Rights Reserved.